<?php
/**
 * @version		$Id: spacer.php 19105 2010-10-13 16:04:55Z chdemko $
 * @package		Joomla.Framework
 * @subpackage	Form
 * @copyright	Copyright (C) 2005 - 2010 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

defined('JPATH_BASE') or die;

jimport('joomla.form.formfield');

/**
 * Form Field class for the Joomla Framework.
 *
 * @package		Joomla.Framework
 * @subpackage	Form
 * @since		1.6
 */
class JFormFieldStyledSpacer extends JFormField
{
	/**
	 * The form field type.
	 *
	 * @var		string
	 * @since	1.6
	 */
	protected $type = 'StyledSpacer';

	/**
	 * Method to get the field input markup.
	 *
	 * @return	string	The field input markup.
	 * @since	1.6
	 */
	protected function getInput()
	{
		return ' ';
	}

	/**
	 * Method to get the field label markup.
	 *
	 * @return	string	The field label markup.
	 * @since	1.6
	 */
	protected function getLabel()
	{
		$html = array();
		$class = $this->element['class'] ? (string) $this->element['class'] : '';
		$style = $this->element['style'] ? (string) $this->element['style'] : '';
		$label = $this->element['label'] ? (string) $this->element['label'] : '';

		if ($class != "" && $style != "")
		{
			$css = "." . $class . " { " . $style . " }";
			$document = &JFactory::getDocument();
			$document->addStyleDeclaration( $css );
		}

		$html[]= '<div class="clr"></div>';
		$html[]='<label class="'.$class.'">';
		if ((string) $this->element['hr'] == 'true') {
			$html[]= '<hr />';
		}
		else {
			$html[]= JText::_($label);
		}
		$html[] = '</label>';
		return implode('',$html);
	}
}
